#/usr/bin/env python
# speed comparison for boost::python c++ using a list as argument
# of size n where n is an arguemtn on the commandline (ugly code!)
import hello
import numpy as np
import scipy.special as sp
import time
import sys

print "------------------------"
print "Content of the hello C++ module"
print dir(hello)
print "------------------------"
a = hello.greet('Peter')

sum = 0.0
if len(sys.argv) > 1:
    n=long(sys.argv[1])
else:
    n=1000
r = np.random.uniform(0,1,n)
start = time.time()
sum = hello.listerf(r.tolist())
end = time.time()
print "C++ Sum of",n,"ERF(x) values, with random x in 0..1:",sum
cplustime = end - start
print "Elapsed:", cplustime

sum = 0.0
start = time.time()
x = sp.erf(r)
sum = np.sum(x)
end = time.time()
print "Python Numpy: Sum of",n,"ERF(x) values, with random x in 0..1:",sum
nptime = end - start
print "Elapsed:", nptime


import math
sum = 0.0
start = time.time()
for i in xrange(n):
    x = math.erf(r[i])
    #print r,x
    sum += x
end = time.time()
print "Python Slow: Sum of",n,"ERF(x) values, with random x in 0..1:",sum
slowtime = end - start
print "Elapsed:", slowtime
